
# ## Attack
# Now we re-open our saved project and specify the attack parameters. For this hardware AES implementation, we use a hamming distance leakage model
# 
# Note that this attack requires only the ciphertext, not the plaintext.

# In[11]:

import chipwhisperer as cw
import chipwhisperer.analyzer as cwa
import numpy as np
from tqdm.notebook import trange
import matplotlib.pyplot as plt

project_file = r'C:\Users\ece-mest-user\Desktop\Power_Analysis_Attack_on_AES\PythonScripts\AES_CPA\Tutorial_HW3_CW305.cwp'
project = cw.open_project(project_file)

attack = cwa.cpa(project, cwa.leakage_models.last_round_state_diff)

# This runs the attack:

attack_results = attack.run()

# The attack results can be saved for later viewing or processing without having to repeat the attack:


# key_guess

attack_results.key_guess()

#print(bytearray(project[0].keys[0]))
print(attack_results.find_maximums()[4][0][2])
print(attack_results)
